    SUBROUTINE Cells_Nodes(Cell_Node_Numbers,Number_of_Nodes,Number_of_Cells,CCN)
        
        Implicit None

     Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
     Integer, Allocatable, Dimension(:,:), INTENT(OUT) :: CCN
     ! CCN : Cells Common node
    Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells

   
    Integer :: i,j,l,a1,a2
    Allocate(CCN(Number_of_Nodes,Number_of_Cells+1))

    Do i=1,Number_of_Nodes
        Do j=1,Number_of_Cells+1
            CCN(i,j) = 0.0
        End Do
    End Do

    Do i=1,Number_of_Nodes
        Do j=1,Number_of_Cells
            CCN(i,1) = i
            Do l=2,4
                a1 = Cell_Node_Numbers(j,l)
                If(a1.eq.i) Then
                    a2 = Cell_Node_Numbers(j,1)
                    CCN(i,j+1) = a2
                End If
            End Do
        End Do
    End Do
    Open(7000, file = 'CCN.txt')
    Do i=1,Number_of_Nodes
            Write(7000,*)  CCN(i,1)," ",CCN(i,2)," ",CCN(i,3)," ",CCN(i,4)," ",CCN(i,5)
            Write(7000,*)  CCN(i,6)," ",CCN(i,7)," ",CCN(i,8)," ",CCN(i,9)," ",CCN(i,10)
            Write(7000,*)  CCN(i,11)," ",CCN(i,12)," ",CCN(i,13),CCN(i,14)," ",CCN(i,15)
            Write(7000,*)  CCN(i,16)," ",CCN(i,17)," ",CCN(i,18),CCN(i,19)," ",CCN(i,20)
            Write(7000,*)  CCN(i,21)," ",CCN(i,22)," ",CCN(i,23),CCN(i,24)," ",CCN(i,25)
            Write(7000,*)  CCN(i,26)," ",CCN(i,27)," ",CCN(i,28),CCN(i,29)
            Write(7000,*) "============================================================="
    End Do

    
    End Subroutine Cells_Nodes