Subroutine Sphere_Nodal_Normal(COG,Sphere,Number_of_Cells,S_Normal)

     Implicit None
!==================================================================================================================
     DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: COG
     Real, Allocatable, Dimension(:), INTENT(IN) :: Sphere
     DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: S_Normal
     Integer, INTENT(IN) :: Number_of_Cells
!==================================================================================================================

     Integer :: i
     Real :: Xc,Yc,Zc,Radius,SAN_Size,SAN_Size1

     Allocate(S_Normal(Number_of_Cells,4))

     Xc = Sphere(1)
     Yc = Sphere(2)
     Zc = Sphere(3)
     Radius = Sphere(4)

     !Open(600,file='S_Normal.txt')
     Do i=1,Number_of_Cells
         SAN_Size = ((COG(i,2) - Xc)**2 + (COG(i,3) - Yc)**2 + (COG(i,4) - Zc)**2)**(0.5)
         S_Normal(i,1) = i
         S_Normal(i,2) = (COG(i,2) - Xc)/SAN_Size
         S_Normal(i,3) = (COG(i,3) - Yc)/SAN_Size
         S_Normal(i,4) = (COG(i,4) - Zc)/SAN_Size
         SAN_Size1 = (S_Normal(i,2)**2 + S_Normal(i,3)**2 + S_Normal(i,4)**2)**(0.5)
        ! Write(600,*)  S_Normal(i,1),"   ",S_Normal(i,2),"   ",S_Normal(i,3),"   ",S_Normal(i,4),"   ",SAN_Size1
        ! Write(600,*)
     End Do
End Subroutine
